// CD2mDlg.cpp : implementation file
//

#include "stdafx.h"
#include "CD2m.h"
#include "CD2mDlg.h"
#include "CodeDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CCD2MDlg dialog

CCD2MDlg::CCD2MDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CCD2MDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CCD2MDlg)
	m_bAutoclose = FALSE;
	m_bAutostart = FALSE;
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	//m_bAutoStart = FALSE;
	//bmpBkgnd.Attach( LoadBitmap(AfxGetInstanceHandle(), MAKEINTRESOURCE(IDB_BKGND)) );
}

CCD2MDlg::~CCD2MDlg() {
}

void CCD2MDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CCD2MDlg)
	DDX_Control(pDX, IDC_DOWNLOADPROGRESS, m_cDLProgress);
	DDX_Check(pDX, IDC_AUTOCLOSE, m_bAutoclose);
	DDX_Check(pDX, IDC_AUTOSTART, m_bAutostart);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CCD2MDlg, CDialog)
	//{{AFX_MSG_MAP(CCD2MDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_START, OnStart)
	ON_BN_CLICKED(IDC_STOP, OnStop)
	ON_BN_CLICKED(IDC_BROWSE, OnBrowse)
	ON_BN_CLICKED(IDC_CODEVIEW, OnCodeview)
	ON_WM_TIMER()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCD2MDlg message handlers

/*
HBRUSH CCD2MDlg::OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor) 
{
	HBRUSH hbr;
	switch ( nCtlColor ) {
	case CTLCOLOR_STATIC:
		pDC->SetTextColor (RGB(255,255,0));
		pDC->SetBkMode( TRANSPARENT );
		hbr = (HBRUSH)GetStockObject(NULL_BRUSH);
		break;
	default:
		hbr = CDialog::OnCtlColor(pDC, pWnd, nCtlColor);
		break;
	}
	return hbr;
}

BOOL CCD2MDlg::OnEraseBkgnd( CDC* pDC ) {
	CRect rect;
	GetClientRect(&rect);
	CDC dc;
	dc.CreateCompatibleDC(pDC);
	CBitmap* pOldBitmap = dc.SelectObject(&bmpBkgnd);
	int iBitmapWidth, iBitmapHeight ;
	int ixOrg, iyOrg;
	
	BITMAP bm;
	bmpBkgnd.GetObject(sizeof(BITMAP),&bm);
	iBitmapWidth = bm.bmWidth;
	iBitmapHeight = bm.bmHeight;
	
	// If our bitmap is smaller than the background and tiling is
	// supported, tile it. Otherwise watch the efficiency - don't
	// spend time setting up loops you won't need.
	
	if (iBitmapWidth  >= rect.Width() &&
		iBitmapHeight >= rect.Height() ) {
		pDC->BitBlt (rect.left, 
		rect.top, 
		rect.Width(),
		rect.Height(),
		&dc,
		0, 0, SRCCOPY);
	}
	else {
		for (iyOrg = 0; iyOrg < rect.Height(); iyOrg += iBitmapHeight) {
			for (ixOrg = 0; ixOrg < rect.Width(); ixOrg += iBitmapWidth) {
				pDC->BitBlt (ixOrg,
							iyOrg,
							rect.Width(),
							rect.Height(),
							&dc,
							0, 0, SRCCOPY);
			}
		}
	}
	dc.SelectObject(pOldBitmap);
	return TRUE;
}
*/

BOOL CCD2MDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	m_d.m_pDlg = this;
	m_bOnError = FALSE;
	GetPreviousSettings();
	UpdateHEXInfo();

	//m_d.LoadHexFile( m_sMicroFile );

	if ( m_bAutostart ) {
		SetWindowText( _T("AutoStart...") );
		SetTimer( 100, 1000, NULL );
	}

	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CCD2MDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CCD2MDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CCD2MDlg::OnOK() {
	if ( m_d.IsDownloading() ) {
		return;
	}
	SaveCurrentSettings();
	//new CFaderWnd(this);
	EndDialog( IDOK );
}

void CCD2MDlg::OnCancel() {
	if ( m_d.IsDownloading() ) {
		return;
	}
	//new CFaderWnd(this);
	EndDialog( IDCANCEL );
}

void CCD2MDlg::UpdateHEXInfo() {
	CFileFind ff;
	CString s;
	GetDlgItem(IDC_HEXFILE)->GetWindowText( s );
	if ( ff.FindFile(s) ) {
		ff.FindNextFile();
		CTime ct;
		ff.GetLastWriteTime( ct );
		s = ct.Format( "Last modified: %A, %B %d, %Y\nat %H:%M:%S." );
		GetDlgItem(IDC_HEXINFO)->SetWindowText( s );
	}
}

void CCD2MDlg::SaveCurrentSettings()
{   
    if ( !IsWindow(m_hWnd) ) {
		return;
    }

	UpdateData();
    CRect rect;
    GetWindowRect( rect );
    AfxGetApp()->WriteProfileInt( _T("Settings"), _T("X"), rect.left );
    AfxGetApp()->WriteProfileInt( _T("Settings"), _T("Y"), rect.top );
	CString s;
	GetDlgItem(IDC_HEXFILE)->GetWindowText( s );
    AfxGetApp()->WriteProfileString( _T("Settings"), _T("m_sMicroFile"), s );
	GetDlgItem(IDC_COMMPORT)->GetWindowText( s );
	AfxGetApp()->WriteProfileString( _T("Settings"), _T("m_sCommport"), s );
	GetDlgItem(IDC_BAUDRATE)->GetWindowText( s );
	_stscanf( s, "%d", &m_iBaudrate );
	AfxGetApp()->WriteProfileInt( _T("Settings"), _T("m_iBaudrate"), m_iBaudrate );
	GetDlgItem(IDC_TRIES)->GetWindowText( s );
	_stscanf( s, "%d", &m_iTries );
	AfxGetApp()->WriteProfileInt( _T("Settings"), _T("m_iTries"), m_iTries );
	GetDlgItem(IDC_WDTTIMEOUT)->GetWindowText( s );
	_stscanf( s, "%u", &m_dwWDTTimeout );
	AfxGetApp()->WriteProfileInt( _T("Settings"), _T("m_dwWDTTimeout"), m_dwWDTTimeout );
	AfxGetApp()->WriteProfileInt( _T("Settings"), _T("m_bAutoclose"), m_bAutoclose );
	AfxGetApp()->WriteProfileInt( _T("Settings"), _T("m_bAutostart"), m_bAutostart );
}

void CCD2MDlg::GetPreviousSettings()
{
    int x = AfxGetApp()->GetProfileInt( _T("Settings"), _T("X"), -1 );
    int y = AfxGetApp()->GetProfileInt( _T("Settings"), _T("Y"), -1 );
	if ( m_sMicroFile.IsEmpty() ) {
		m_sMicroFile = AfxGetApp()->GetProfileString( _T("Settings"), _T("m_sMicroFile"), _T("C:\\") );
	}
    m_sCommport = AfxGetApp()->GetProfileString( _T("Settings"), _T("m_sCommport"), _T("COM1") );
    m_iBaudrate = AfxGetApp()->GetProfileInt( _T("Settings"), _T("m_iBaudrate"), 19200 );
    m_iTries = AfxGetApp()->GetProfileInt( _T("Settings"), _T("m_iTries"), 5 );
	m_dwWDTTimeout = AfxGetApp()->GetProfileInt( _T("Settings"), _T("m_dwWDTTimeout"), 100 );
	m_bAutoclose = AfxGetApp()->GetProfileInt( _T("Settings"), _T("m_bAutoclose"), 0 );
	m_bAutostart = AfxGetApp()->GetProfileInt( _T("Settings"), _T("m_bAutostart"), 0 );

	GetDlgItem(IDC_HEXFILE)->SetWindowText( m_sMicroFile );
	GetDlgItem(IDC_COMMPORT)->SetWindowText( m_sCommport );
	CString s;
	s.Format( "%d", m_iBaudrate );
	GetDlgItem(IDC_BAUDRATE)->SetWindowText( s );
	s.Format( "%d", m_iTries );
	GetDlgItem(IDC_TRIES)->SetWindowText( s );
	s.Format( "%u", m_dwWDTTimeout );
	GetDlgItem(IDC_WDTTIMEOUT)->SetWindowText( s );

    if ( x >= 0 && x < GetSystemMetrics(SM_CXSCREEN) &&
        y >= 0 && y < GetSystemMetrics(SM_CYSCREEN) ) {
        SetWindowPos( NULL, x, y, 0, 0, SWP_NOSIZE|SWP_NOZORDER );
    }
    else {
        CenterWindow();
    }
	UpdateData( FALSE );
}

void CCD2MDlg::OnStart() 
{
	UpdateHEXInfo();
	GetDlgItem(IDC_HEXFILE)->GetWindowText( m_sMicroFile );
	GetDlgItem(IDC_COMMPORT)->GetWindowText( m_sCommport );
	CString s;
	GetDlgItem(IDC_BAUDRATE)->GetWindowText( s );
	_stscanf( s, _T("%d"), &m_iBaudrate );
	GetDlgItem(IDC_TRIES)->GetWindowText( s );
	_stscanf( s, _T("%d"), &m_iTries );
	GetDlgItem(IDC_WDTTIMEOUT)->GetWindowText( s );
	_stscanf( s, _T("%u"), &m_dwWDTTimeout );
	if ( !m_d.DownloadStart(m_sMicroFile,m_sCommport,m_iBaudrate,m_iTries,m_dwWDTTimeout) ) {
		if ( !m_bOnError )
			SetWindowText( _T("Download failed.") );
	}
	else {
		UpdateData();
		if ( m_bAutoclose ) {
			Sleep( 1000 );
			OnOK();
		}
	}
}

void CCD2MDlg::OnStop() 
{
	m_d.DownloadStop();
}

int CCD2MDlg::GetTries() {
	return m_iTries;
}

void CMyDownloader::OnLooking( DWORD n ) {
	CString s;
	s.Format( _T("Looking for bootloader...[%u/%d]"), n, ((CCD2MDlg*)m_pDlg)->GetTries() );
	m_pDlg->SetWindowText( s );
}

void CMyDownloader::OnDownloadProgress( DWORD n ) {
	CProgressCtrl* p = (CProgressCtrl*)m_pDlg->GetDlgItem(IDC_DOWNLOADPROGRESS);
	p->SetPos( n );
}

void CMyDownloader::OnDownloadDone() {
	m_pDlg->SetWindowText( _T("Code has been downloaded.") );
}

void CMyDownloader::OnDownload() {
	CProgressCtrl* p = (CProgressCtrl*)m_pDlg->GetDlgItem(IDC_DOWNLOADPROGRESS);
	p->SetRange( 0, 100 );
	m_pDlg->SetWindowText( _T("Downloading...") );
}

void CMyDownloader::OnHEXFileLoaded() {
	m_pDlg->SetWindowText( _T("HEX file loaded.") );
}

void CMyDownloader::OnError( DWORD dwE ) {
	CString s;
	s.Format( _T("Error: %d"), dwE );
	CCD2MDlg* p = (CCD2MDlg*)m_pDlg;
	p->SetWindowText( s );
	p->m_bOnError = TRUE;
}

void CMyDownloader::OnContact() {
	m_pDlg->SetWindowText( _T("Bootloader has been found.") );
}

void CMyDownloader::OnDownloadStart() {
	m_pDlg->SetWindowText( _T("Looking for bootloader...") );
}

void CCD2MDlg::OnBrowse() 
{
	CString s;
	s.LoadString( IDS_HEXCOFFILTER );
    DWORD dwFlags = OFN_EXPLORER|OFN_LONGNAMES|OFN_PATHMUSTEXIST;
	CFileDialog fd(TRUE, NULL, NULL, dwFlags, s, NULL);
	int iRet = fd.DoModal();
	if ( IDOK == iRet ) {
		s = fd.GetPathName();
		GetDlgItem(IDC_HEXFILE)->SetWindowText( s );
		UpdateHEXInfo();
		m_sMicroFile = s;
	}
}

void CCD2MDlg::OnCodeview() 
{
	CCodeDlg m_code;
	m_code.SetCodeMem( m_d.GetCodeMem() );
	m_d.LoadMicroFile( m_sMicroFile );
	int iRet = m_code.DoModal();
}

void CCD2MDlg::OnTimer(UINT nIDEvent) 
{
	switch ( nIDEvent ) {
	case 100:
		KillTimer( nIDEvent );
		OnStart();
		//Sleep( 1000 );
		//OnOK();
		break;
	}
	CDialog::OnTimer(nIDEvent);
}
