// CodeDlg.cpp : implementation file
//

#include "stdafx.h"
#include "cd2m.h"
#include "CodeDlg.h"
#include "cd2mdlg.h"
#include "faderwnd.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CCodeDlg dialog


CCodeDlg::CCodeDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CCodeDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CCodeDlg)
	//}}AFX_DATA_INIT
}

CCodeDlg::~CCodeDlg() {
}

void CCodeDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CCodeDlg)
	DDX_GridControl(pDX, IDC_CUSTOM1, m_CODEGrid);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CCodeDlg, CDialog)
	//{{AFX_MSG_MAP(CCodeDlg)
	ON_WM_SHOWWINDOW()
	ON_BN_CLICKED(IDC_RETLW_ASCII, OnRetlwAscii)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCodeDlg message handlers

void CCodeDlg::UpdateCodeView() {
	CString s;
	int i = 0;
	GV_ITEM Item;
	Item.mask = GVIF_TEXT|GVIF_FORMAT;

	SetWindowText( _T("Please wait...") );
	for ( DWORD lines=0;lines<m_dwLines;lines++ ) {
		Item.col = 0;
		Item.row = lines+1;
		s.Format( _T("%04u"), lines+1 );
		Item.strText = s;
		Item.nFormat = DT_CENTER;
		m_CODEGrid.SetItem( &Item );
		s.Format( _T("%04X"), lines );
		Item.col = 1;
		Item.strText = s;
		m_CODEGrid.SetItem( &Item );
		if ( (int)m_pC[i].iAddress == lines ) {
			s.Format( _T("%02X%02X"), m_pC[i].data[0], m_pC[i].data[1] );
			Item.col = 2;
			Item.strText = s;
			m_CODEGrid.SetItem( &Item );
			Disassembly( m_pC[i].data, s );
			Item.col = 3;
			Item.strText = s;
			Item.nFormat = DT_LEFT;
			m_CODEGrid.SetItem( &Item );
			i++;
		}
		else {
			s.Format( _T("3FFF") );
			Item.col = 2;
			Item.strText = s;
			m_CODEGrid.SetItem( &Item );
			s = _T("ADDLW 0xFF");
			Item.col = 3;
			Item.strText = s;
			Item.nFormat = DT_LEFT;
			m_CODEGrid.SetItem( &Item );
		}
	}
	i++;
	s.Format( _T("Code View: [%d words, usage: %d words, %3.2f%%]"), m_dwLines, i, ((float)i/(float)m_dwLines)*100.0 );
	SetWindowText( s );

	m_CODEGrid.AutoSize();
}

BOOL CCodeDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	m_sRETLW = _T("RETLW 0x%02X");
	CheckDlgButton( IDC_RETLW_ASCII, 0 );
	m_dwLines = 2048;
	//m_CODEGrid.EnableWysiwygPrinting();
	m_CODEGrid.SetColumnCount( 4 );
	for ( int ii=0;ii<8192;ii++ ) {
		if ( m_pC[ii].iAddress > m_dwLines && m_pC[ii].iAddress < 65536 ) {
			m_dwLines *= 2;
		}
	}
	m_CODEGrid.SetRowCount( m_dwLines+1 );
	m_CODEGrid.SetFixedRowCount( 1 );
	m_CODEGrid.SetFixedColumnCount( 1 );
	m_CODEGrid.SetEditable( FALSE );
	GV_ITEM Item;
	Item.mask = GVIF_TEXT|GVIF_FORMAT;
	Item.col = 0;
	Item.row = 0;
	Item.strText = _T("Line");
	m_CODEGrid.SetItem( &Item );
	Item.col = 1;
	Item.strText = _T("Address");
	m_CODEGrid.SetItem( &Item );
	Item.col = 2;
	Item.strText = _T("Opcode");
	m_CODEGrid.SetItem( &Item );
	Item.col = 3;
	Item.strText = _T("Disassembly");
	m_CODEGrid.SetItem( &Item );

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CCodeDlg::Disassembly( BYTE* Opcode, CString& s ) {
	short Opcode_tmp = (*(short*)Opcode);
	BYTE instruction;
	BYTE d;
	BYTE f;
	short k;
	BYTE b;
	d &= 0x01;

	switch ( Opcode_tmp ) {
	case 0x6400:
		s = _T("CLRWDT");
		break;
	case 0x0900:
		s = _T("RETFIE");
		break;
	case 0x0800:
		s = _T("RETURN");
		break;
	case 0x0063:
		s = _T("SLEEP");
		break;
	case 0x0000:
	case 0x2000:
	case 0x4000:
	case 0x6000:
		s = _T("NOP");
		break;
	default:
		switch ( (*Opcode)&0x30 ) {
		case 0:
			instruction = *Opcode;
			d = (*(++Opcode))>>7;
			f = (*Opcode)&0x7F;
			switch ( instruction ) {
			case 0:
				if ( d == 1 ) {
					s.Format( _T("MOVWF 0x%02X"), f );
				}
				else {
					s.Format( _T("MOVWF 0x%02X"), f );
				}
				break;
			case 1:
				if ( d == 1 ) {
					s.Format( _T("CLRF 0x%02X"), f );
				}
				else {
					s = _T("CLRW");
				}
				break;
			case 2:
				s.Format( _T("SUBWF 0x%02X,%d"), f, d );
				break;
			case 3:
				s.Format( _T("DECF 0x%02X,%d"), f, d );
				break;
			case 4:
				s.Format( _T("IORWF 0x%02X,%d"), f, d );
				break;
			case 5:
				s.Format( _T("ANDWF 0x%02X,%d"), f, d );
				break;
			case 6:
				s.Format( _T("XORWF 0x%02X,%d"), f, d );
				break;
			case 7:
				s.Format( _T("ADDWF 0x%02X,%d"), f, d );
				break;
			case 8:
				s.Format( _T("MOVF 0x%02X,%d"), f, d );
				break;
			case 9:
				s.Format( _T("COMF 0x%02X,%d"), f, d );
				break;
			case 0x0A:
				s.Format( _T("INCF 0x%02X,%d"), f, d );
				break;
			case 0x0B:
				s.Format( _T("DECFSZ 0x%02X,%d"), f, d );
				break;
			case 0x0C:
				s.Format( _T("RRF 0x%02X,%d"), f, d );
				break;
			case 0x0D:
				s.Format( _T("RLF 0x%02X,%d"), f, d );
				break;
			case 0x0E:
				s.Format( _T("SWAPF 0x%02X,%d"), f, d );
				break;
			case 0x0F:
				s.Format( _T("INCFSZ 0x%02X,%d"), f, d );
				break;
			}
			break;
		case 0x10:
			b = ((*Opcode)&3)<<1;
			b += ((*(++Opcode))&0x80)>>7;
			f = (*Opcode)&0x7F;
			switch ( (*(--Opcode))&0x1C ) {
			case 0x10:
				s.Format( _T("BCF 0x%02X,%d"), f, b );
				break;
			case 0x14:
				s.Format( _T("BSF 0x%02X,%d"), f, b );
				break;
			case 0x18:
				s.Format( _T("BTFSC 0x%02X,%d"), f, b );
				break;
			case 0x1C:
				s.Format( _T("BTFSS 0x%02X,%d"), f, b );
				break;
			}
			break;
		case 0x20:
			k = Opcode_tmp&0xFF00;
			k = (k>>8)&0xFF;
			k = k + ((Opcode_tmp&0x0007)<<8);
			switch ( (*Opcode)&0x28 ) {
			case 0x20:
				s.Format( _T("CALL 0x%03X"), k );
				break;
			case 0x28:
				s.Format( _T("GOTO 0x%03X"), k );
				break;
			}
			break;
		case 0x30:
			k = Opcode_tmp&0xFF00;
			k = (k>>8)&0xFF;
			switch ( (*Opcode)&0x3F ) {
			case 0x3E:
			case 0x3F:
				s.Format( _T("ADDLW 0x%02X"), k );
				break;
			case 0x39:
				s.Format( _T("ANDLW 0x%02X"), k );
				break;
			case 0x38:
				s.Format( _T("IORLW 0x%02X"), k );
				break;
			case 0x30:
			case 0x31:
			case 0x32:
			case 0x33:
				s.Format( _T("MOVLW 0x%02X"), k );
				break;
			case 0x34:
			case 0x35:
			case 0x36:
			case 0x37:
				s.Format( m_sRETLW, k );
				break;
			case 0x3C:
			case 0x3D:
				s.Format( _T("SUBLW 0x%02X"), k );
				break;
			case 0x3A:
				s.Format( _T("XORLW 0x%02X"), k );
				break;
			}
			break;
		}
	}
}

CCodeDlg::SetCodeMem( PROGDATA* p ) {
	m_pC = p;
}

void CCodeDlg::OnShowWindow(BOOL bShow, UINT nStatus) 
{
	CDialog::OnShowWindow(bShow, nStatus);
	UpdateCodeView();	
}

void CCodeDlg::OnOK() {
	new CFaderWnd(this);
	EndDialog( IDOK );
}

void CCodeDlg::OnCancel() {
	new CFaderWnd(this);
	EndDialog( IDCANCEL );
}

void CCodeDlg::OnRetlwAscii() 
{
	if ( IsDlgButtonChecked(IDC_RETLW_ASCII) ) {
		m_sRETLW = _T("RETLW '%c'");
	}
	else {
		m_sRETLW = _T("RETLW 0x%02X");
	}
	UpdateCodeView();
}
