// Downloader.h: interface for the CDownloader class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_DOWNLOADER_H__34534AD7_4960_4DB9_8C65_B63DD605A56F__INCLUDED_)
#define AFX_DOWNLOADER_H__34534AD7_4960_4DB9_8C65_B63DD605A56F__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "..\picboot\picboot.h"

#define DOWNLOADER_ERROR_BADHEXFORMAT	-100
#define DOWNLOADER_ERROR_CANTHANDLEREC	-101
#define DOWNLOADER_ERROR_DATA			-102
#define DOWNLOADER_ERROR_BADWRITE		-103

typedef struct tagPROGDATA {
	unsigned int	iAddress;
	BYTE			data[2];
}PROGDATA;

class CDownloader {
public:
	CDownloader();
	virtual ~CDownloader();
	virtual void OnLooking( DWORD n );
	virtual void OnContact();
	virtual void OnDownloadStart();
	virtual void OnError( DWORD dwE );
	virtual void OnHEXFileLoaded();
	virtual void OnDownload();
	virtual void OnDownloadDone();
	virtual void OnDownloadProgress( DWORD n );
	CString	m_sHEXFile;
	PROGDATA* LoadHexFile( LPCTSTR lpsHexFile );
	PROGDATA* GetCodeMem();
	CString UpdateHEXInfo( LPCTSTR fn );
	BOOL IsDownloading();
	void DownloadStop();
	BOOL DownloadStart( LPCTSTR pszHexFile,
				LPCTSTR pszCOM=_T("COM1"),
				int iBaudRate=CBR_115200,
				int iTries=5 );

protected:
	PROGDATA pd[ROM_SIZE];
	volatile BOOL m_bStop;
	BOOL	m_bAsync;
	BOOL	m_bCommOpened;
	CString m_sCommport;
	int		m_iBaudrate;
	HANDLE	m_hCommport;
	TCHAR	m_chResetAck;
	TCHAR	m_chResetCmd;
	DWORD	m_dwTotal;
	int		m_iTries;
	BYTE gx( BYTE c );
	UINT g2x( BYTE *s );
	UINT g4x( BYTE *s );
	BOOL _LoadHexFile( void );
	void _PeekAndPump( void );
	BOOL _Run( void );
	BOOL _Download( void );
	BOOL _MakeContact( void );
	BOOL _SendByte( BYTE b );
	BYTE _GetByte();
	DWORD _commopen( void );
	void _commclose( void );
	DWORD _commwrite( LPVOID pB, DWORD n );
	DWORD _commread(  LPVOID pB, DWORD n );
	void _commpurge( void );
};

#endif // !defined(AFX_DOWNLOADER_H__34534AD7_4960_4DB9_8C65_B63DD605A56F__INCLUDED_)
